searchNodes=[{"doc":"ExZample is a factory library based on Elixir behaviours.","ref":"ExZample.html","title":"ExZample","type":"behaviour"},{"doc":"Builds a struct with given factory_or_alias module. If the given factory exports the example/0 function it will use to return the struct and its values. Otherwise, if the module is a struct it will use its default values. If will override the generated data with the given attrs. Examples iex&gt; ExZample.build(User) %ExZample.User{} iex&gt; ExZample.build(UserFactory) %ExZample.User{age: 21, email: &quot;test@test.test&quot;, first_name: &quot;First Name&quot;, id: 1, last_name: &quot;Last Name&quot;} iex&gt; ExZample.build(:book) %ExZample.Book{code: &quot;1321&quot;, title: &quot;The Book&#39;s Title&quot;} iex&gt; ExZample.build(User, age: 45) %ExZample.User{age: 45} iex&gt; ExZample.build(UserFactory, age: 45) %ExZample.User{age: 45, email: &quot;test@test.test&quot;, first_name: &quot;First Name&quot;, id: 1, last_name: &quot;Last Name&quot;} iex&gt; ExZample.build(:book, code: &quot;007&quot;) %ExZample.Book{code: &quot;007&quot;, title: &quot;The Book&#39;s Title&quot;}","ref":"ExZample.html#build/2","title":"ExZample.build/2","type":"function"},{"doc":"Same as build/2, but returns a list with where the size is the given count. Examples iex&gt; ExZample.build_list(3, User) [%ExZample.User{}, %ExZample.User{}, %ExZample.User{}] iex&gt; ExZample.build_list(3, :book) [%ExZample.Book{},%ExZample.Book{}, %ExZample.Book{}] iex&gt; ExZample.build_list(3, User, age: 45) [%ExZample.User{age: 45}, %ExZample.User{age: 45}, %ExZample.User{age: 45}] iex&gt; ExZample.build_list(3, :book, code: &quot;007&quot;) [%ExZample.Book{code: &quot;007&quot;},%ExZample.Book{code: &quot;007&quot;}, %ExZample.Book{code: &quot;007&quot;}]","ref":"ExZample.html#build_list/3","title":"ExZample.build_list/3","type":"function"},{"doc":"Same as build/2, but returns a tuple with a pair of structs. Examples iex&gt; ExZample.build_pair(User) {%ExZample.User{}, %ExZample.User{}} iex&gt; ExZample.build_pair(:book) {%ExZample.Book{},%ExZample.Book{}} iex&gt; ExZample.build_pair(User, age: 45) {%ExZample.User{age: 45}, %ExZample.User{age: 45}} iex&gt; ExZample.build_pair(:book, code: &quot;007&quot;) {%ExZample.Book{code: &quot;007&quot;},%ExZample.Book{code: &quot;007&quot;}}","ref":"ExZample.html#build_pair/2","title":"ExZample.build_pair/2","type":"function"},{"doc":"Creates aliases for your factories to simplify the build calls. A aliases should be a map with atom keys and values as factory compatible modules. If you call with repeated keys this function will fail. This function is ideal to be called once, for example in your test_helper.ex file. Examples iex&gt; ExZample.config_aliases(%{user: UserFactory}) ...&gt; ExZample.build(:user) %User{age: 21, email: &quot;test@test.test&quot;, first_name: &quot;First Name&quot;, id: 1, last_name: &quot;Last Name&quot;}","ref":"ExZample.html#config_aliases/1","title":"ExZample.config_aliases/1","type":"function"},{"doc":"Same as config_aliases/1, but you can define a different scope. This function is specially useful for umbrella apps where each app can define their factories without leaking any aliases to other apps. You can enforce the current scope with ex_zample/1. Examples iex&gt; ExZample.config_aliases(:my_app, %{user: UserFactory}) ...&gt; ExZample.ex_zample(%{ex_zample_scope: :my_app}) ...&gt; ExZample.build(:user) %User{age: 21, email: &quot;test@test.test&quot;, first_name: &quot;First Name&quot;, id: 1, last_name: &quot;Last Name&quot;}","ref":"ExZample.html#config_aliases/2","title":"ExZample.config_aliases/2","type":"function"},{"doc":"Creates a sequence with the given name. A sequence is global runtime counter that can be invoked with sequence/1. The default counter starts from 1 and increments 1 by 1. Examples iex&gt; ExZample.create_sequence(:user_id) ...&gt; Enum.map(1..10, fn _ -&gt; ExZample.sequence(:user_id) end) [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]","ref":"ExZample.html#create_sequence/1","title":"ExZample.create_sequence/1","type":"function"},{"doc":"Same as create_sequence/1, but you can define a different scope or a sequence function. When use with scope and name you define scoped global counter, it&#39;s useful for umbrella apps for example. When you use name and sequence_fun, the given function will receive the counter and then you can transform in anything you want. Examples iex&gt; ExZample.create_sequence(:my_app, :user_id) ...&gt; ExZample.ex_zample(%{ex_zample_scope: :my_app}) ...&gt; ExZample.sequence(:user_id) 1 iex&gt; ExZample.create_sequence(:user_id, &amp;(&quot;user_&quot; &lt;&gt; to_string(&amp;1))) ...&gt; Enum.map(1..3, fn _ -&gt; ExZample.sequence(:user_id) end) [&quot;user_1&quot;, &quot;user_2&quot;, &quot;user_3&quot;]","ref":"ExZample.html#create_sequence/2","title":"ExZample.create_sequence/2","type":"function"},{"doc":"Same as create_sequence/1, but you can define a different scope and a sequence function. The scope is where where your global counter will lives, useful for umbrella apps for example. The given sequence_fun will receive the counter and then you can transform in anything you want. Examples iex&gt; ExZample.create_sequence(:my_app, :user_id, &amp;(&quot;user_&quot; &lt;&gt; to_string(&amp;1))) ...&gt; ExZample.ex_zample(%{ex_zample_scope: :my_app}) ...&gt; Enum.map(1..3, fn _ -&gt; ExZample.sequence(:user_id) end) [&quot;user_1&quot;, &quot;user_2&quot;, &quot;user_3&quot;]","ref":"ExZample.html#create_sequence/3","title":"ExZample.create_sequence/3","type":"function"},{"doc":"Utiliy function that you can define the scope that ExZample will look for the aliases. If no scope is defined, :global is the default scope. This function works well with setup/1 callback of ExUnit and @tags. For example: defmodule MyTest do use ExUnit.Case import ExZample @moduletag %{ex_zample_scope: :my_app} setup :ex_zample test &quot;returns a user&quot; do assert %User{} == build(:user) end end In the example above, ExZample will look for a factory registered in alias :user in the :my_app scope.","ref":"ExZample.html#ex_zample/1","title":"ExZample.ex_zample/1","type":"function"},{"doc":"Invoked every time you build your data using ExZample module. You need to return a struct with example values. This callback is optional when the module given is a struct. It will use the struct default values if no callback is given.","ref":"ExZample.html#c:example/0","title":"ExZample.example/0","type":"callback"},{"doc":"Same as example/0, but here you have the full control in how will build your struct given the attributes. The keyword list given in functions like build/2 are transformed in map for your convenience and you need to return a struct. You can have two scenarios when using this callback: If you define example/0 and example/1 in same factory, example/0 will be prefered when you use build/1. The example/1 will preferend if you use with build/2. If you only implement example/1 and use build/1, your callback will invoked with an empty map. This callback is optional.","ref":"ExZample.html#c:example/1","title":"ExZample.example/1","type":"callback"},{"doc":"Returns the current counter registered in the given sequence name. Examples iex&gt; ExZample.create_sequence(:user_id, &amp;(&quot;user_&quot; &lt;&gt; to_string(&amp;1))) ...&gt; ExZample.sequence(:user_id) &quot;user_1&quot;","ref":"ExZample.html#sequence/1","title":"ExZample.sequence/1","type":"function"},{"doc":"Same as sequence/1, but returns a list of where the number is determined by the given count. Examples iex&gt; ExZample.create_sequence(:user_id, &amp;(&quot;user_&quot; &lt;&gt; to_string(&amp;1))) ...&gt; ExZample.sequence_list(3, :user_id) [&quot;user_1&quot;, &quot;user_2&quot;, &quot;user_3&quot;]","ref":"ExZample.html#sequence_list/2","title":"ExZample.sequence_list/2","type":"function"},{"doc":"Same as sequence/1, but returns a pair of sequence items. Examples iex&gt; ExZample.create_sequence(:user_id, &amp;(&quot;user_&quot; &lt;&gt; to_string(&amp;1))) ...&gt; ExZample.sequence_pair(:user_id) {&quot;user_1&quot;, &quot;user_2&quot;}","ref":"ExZample.html#sequence_pair/1","title":"ExZample.sequence_pair/1","type":"function"},{"doc":"","ref":"ExZample.html#t:factory/0","title":"ExZample.factory/0","type":"type"},{"doc":"","ref":"ExZample.html#t:sequence_fun/0","title":"ExZample.sequence_fun/0","type":"type"},{"doc":"Defines a domain-speficic language(DSL) to simplify the creation of your factories. You can use this DSL by using by defining a module and adding the use directive. For example: defmodule MyApp.Factories do use ExZample.DSL alias MyApp.User factory :user do example do %User{ id: 33, first_name: &quot;Abili&quot; last_name: &quot;de bob&quot; } end end end It will generate the modules and the aliases manifest to be loaded when the ex_zample app starts. Then, to use your factories, don&#39;t forget to start your app. For example: # in your test_helper.exs :ok = Application.ensure_started(:ex_zample) This way, all factorites your defined using the ExZample.DSL will be loaded module. Options You can pass the following options to the use directive: scope (default: :global), the :scope that all aliases of factories will be stored","ref":"ExZample.DSL.html","title":"ExZample.DSL","type":"module"},{"doc":"Defines a module factory with helpers imported by default. If you pass an atom for factory name, such as user, the module will be generated with UserFactory. If you pass a scope, like: my_app: :user, the module name will become MyAppUserFactory. The factory body has all functions from ExZample imported. It also has access to example DSL helper that generates a function definition with behaviour annotations. Taking those helpers out, everything else work as normal Elixir module.","ref":"ExZample.DSL.html#factory/2","title":"ExZample.DSL.factory/2","type":"macro"},{"doc":"ExZample A scalable error-friendly factories library for your Elixir apps","ref":"readme.html","title":"ExZample","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding ex_zample to your list of dependencies in mix.exs: def deps do [ {:ex_zample, &quot;~&gt; 0.6.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/ex_zample.","ref":"readme.html#installation","title":"ExZample - Installation","type":"extras"},{"doc":"You can build any struct by passing a struct module: ExZample.build(User) # =&gt; %MyApp.User{first_name: nil, age: 21} ExZample will automatically use the default values inside of that struct. If you want to define different values, you can create factories using ExZample.DSL. For example: defmodule MyApp.Factories do use ExZample.DSL alias ExZample.User factory :user do example do %User{ first_name: &quot;Abili De Bob&quot;, age: 12, } end end end # Don&#39;t forget to start :ex_zample app! # for example, in your: test_helper.exs :ok = Application.ensure_started(:ex_zample) Now you can invoke them like this: ExZample.build(:user) # =&gt; %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 12} This is the basics of what you need to start using ExZample. The later section of this README we&#39;ll dig in details of how this library works.","ref":"readme.html#quick-start","title":"ExZample - Quick Start","type":"extras"},{"doc":"You can use the build/2, build_pair/2 and build_list/3 to generate data without side-effects. # or using aliases ExZample.build(:user, age: 42) # =&gt; %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42} ExZample.build_pair(:user, age: 42) # =&gt; {%MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}, %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}} ExZample.build_list(100, :user, age: 42) # =&gt; [ # %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}, # %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}, # ... # ] # or using the modules directly ExZample.build(UserFactory, age: 42) # =&gt; %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42} ExZample.build_pair(UserFactory, age: 42) # =&gt; {%MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}, %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}} ExZample.build_list(100, UserFactory, age: 42) # =&gt; [ # %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}, # %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 42}, # ... # ] When you pass attributes, it will override the default ones defined in your factories.","ref":"readme.html#building-your-factories","title":"ExZample - Building your factories","type":"extras"},{"doc":"Sequences are global counters that you can user in your tests. When your test suite starts you can create sequences using ExZample.create_sequence. For example, in your test_helper.exs: # test_helper.exs :ok = Application.ensure_started(:ex_zample) ExZample.create_sequence(:order_id) ExZample.create_sequence(:user_email, &amp;&quot;email_\#{&amp;1}@test.test&quot;) Then, in your factories or in your tests you can invoke them using ExZample.sequence/1 this: factory :user do example do %User{ email: sequence(:user_email), name: &quot;Abili de bob&quot; } end end # or in your tests test &quot;tracks an order&quot; do order_id = ExZample.sequence(:order_id) # =&gt; 1 end Sequences are Agent processes, no matter how many processes tries to get the next value, the OTP will guarantee it will always generate a different one for each request. ExZample and Umbrella apps If you want to avoid the factories or sequences leaking through different apps in your umbrella, you can define them under a scope. # defining factories defmodule MyApp.Factories do use ExZample.DSL, scope: :app_a alias ExZample.User factory :user do example do %User{ first_name: &quot;Abili De Bob&quot;, age: 12, } end end end # in apps/myapp_a/test/test_helper.ex ExZample.create_sequence(:app_a, :user_email, &amp;&quot;user_\#{&amp;1}@test.test&quot;) Then, you can use ExZample.ex_zample/1 to narrow the scope of lookups during in your tests. It fits well with ExUnit @tags and setup/1 callbacks. For example, if you are working in a Phoenix app, you can put general scope enforcement in your test/support/data_case.ex file: defmodule MyApp.DataCase do @moduledoc false use ExUnit.CaseTemplate using do quote do # Tells [`ExZample`](ExZample.html) which scope you want to look up for your aliases @moduletag ex_zample_scope: :app_a import Ecto import Ecto.Changeset import Ecto.Query # import ExZample (optional, import the utility functions like `build/2`, `sequence/1`) end end # Makes [`ExZample`](ExZample.html) narrow the scope of aliases based on the configured tag # If you have imported the [`ExZample`](ExZample.html), you can do: `setup :ex_zample` setup &amp;ExZample.ex_zample/1 setup tags do :ok = Sandbox.checkout(Repo) unless tags[:async] do Sandbox.mode(Repo, {:shared, self()}) end :ok end end Using the the configuration above and narrowing the scope you can have stronger boundary between your Umbrella apps.","ref":"readme.html#sequences","title":"ExZample - Sequences","type":"extras"},{"doc":"All your module need to do to use the ExZample functions is your implement the example/0 or example/1 callback. defmodule MyApp.User do @behaviour ExZample defstruct first_name: nil, age: 21 @impl true def example do %__MODULE__{first_name: &quot;Abili De Bob&quot;, age: 12} end end # later ExZample.build(MyApp.User) # =&gt; %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 12} When you implement the example callback, any module can be a factory.","ref":"readme.html#using-structs-as-factories","title":"ExZample - Using structs as factories.","type":"extras"},{"doc":"If you want to separate your test data from your app code, you can define a factory in a different module from your struct: defmodule MyApp.User do defstruct first_name: nil, age: 21 end defmodule MyApp.Factories.UserFactory do @behaviour ExZample alias MyApp.User @impl true def example do %User{first_name: &quot;Abili De Bob&quot;, age: 12} end end # later alias MyApp.Factories.UserFactory ExZample.build(UserFactory) # =&gt; %MyApp.User{first_name: &quot;Abili De Bob&quot;, age: 12} You don&#39;t to type all this boilerplate code if you use the ExZample.DSL. You can implement the example/1 callback when you want to have full control in how your factories are built: @impl true def example(attrs) do age = Map.get(attrs, :age, 12) * 2 first_name = Map.get(attrs, :first_name, &quot;Abilid&quot;) &lt;&gt; &quot; De Bob&quot; %User{first_name: first_name, age: age} end # later build(:user, first_name: &quot;Alice&quot;) # =&gt; %User{first_name: &quot;Alice De Bob&quot;, age: 24} The Example.DSL also supports the full control of your factories: factory :user do import Map, only: [get: 3] example(attrs) do %User{ first_name: attrs |&gt; get(:first_name, &quot; De Bob&quot;) |&gt; prefix(), age: get(attrs, :age, 12) * 2, } end defp prefix(string), do: &quot;Abilid \#{string}&quot; end As you can see, the body of the factory directive works as any Elixir module. You can import and define helpers functions.","ref":"readme.html#defining-manually-your-factory-modules","title":"ExZample - Defining manually your factory modules","type":"extras"},{"doc":"If don&#39;t want to use the ExZample.DSL, you can manually define a nickname for your factories. For example, in your test_helper.ex, after starting ex_zample, you can call ExZample.config_aliases/1. # in your test_helper.exs # Don&#39;t forget to start :ex_zample app! :ok = Application.ensure_started(:ex_zample) # defining manually your aliases ExZample.config_aliases(%{user: UserFactory}) # later in your app_test.exs test &quot;activates an user&quot; do user = ExZample.build(:user) assert :ok == MyApp.active_user(user) end","ref":"readme.html#manually-defining-your-aliases","title":"ExZample - Manually defining your aliases","type":"extras"},{"doc":"This library was strongly inspired by: ExMachina FactoryBot","ref":"readme.html#inspiration","title":"ExZample - Inspiration","type":"extras"},{"doc":"Right now you shouldn&#39;t change for this one. The other factories libraries has much more features. However, when your codebase starts to get bigger, it&#39;s nice to have a way to split up your factories files in multiple files. Also, it&#39;s important when a error happens, it should be explicit and easy to reason about. Most of other Elixir libraries relies on DLS with macro code, and you need to write macros to split up your factories files. When you get some error in your factory, it&#39;s very hard to locate where is the real problem. This library approach is to rely on vanilla Elixir modules and contracts based on Elixir behaviours. No need to use any macro. The purpose for any macro that can shows up here will be for syntax sugar, not part of the main functionality.","ref":"readme.html#why-not-other-factories-libraries","title":"ExZample - Why not other factories libraries?","type":"extras"},{"doc":"Probably not, you can define your own modules to return example structs and insert them with your repo module. However, a factory library can give you some convenient functions for you don&#39;t need to reinvent the wheel.","ref":"readme.html#do-i-really-need-a-factory-library","title":"ExZample - Do I really need a factory library?","type":"extras"}]